
slop=0.5;
bigslop=slop*2;

prongthick=5;
prongwidth=5;
ratchetstep=15;
ratchettooth=3;
ratchettoothheight=5;
ratchettoothsmoothr=1;
ratchettoothslope=0.75;
overlap=0.5;
cupbigrad=35;

prongstalkxwidth=3;

stalklength=40;
overclipcupgap=5;
overclipdepth=15;
overcliproundr=2.0;
overclipthick=0.5;

wingspoke=3;
wingsize=6;
wingthick=3;

overclipsmaller=-1.0;
overclipbigger=2.0;

armendwallthick=2.5;
armendbasethick=1.2;

ratchetpawl=ratchetstep-ratchettooth-bigslop*2;

include <doveclip.scad>
include <cliphook.scad>

channelwidth = prongthick + slop;
channeldepth = prongwidth + ratchettoothheight;
totalwidth = armendwallthick*2 + channelwidth;
totalheight = channeldepth + armendbasethick;
stalkwidth = prongwidth + prongstalkxwidth;

doveclipheight = totalheight;

module ArmEnd(length=120){
  translate([ratchettoothsmoothr, channelwidth/2, -armendbasethick]) {
    rotate([0,0,-90])
      DoveClipPairBase(h=doveclipheight);
  }

  difference(){
    translate([0, -armendwallthick, -armendbasethick])
      cube([length, totalwidth, totalheight]);
    translate([-1, 0, 0])
      cube([length+2, channelwidth, channeldepth+1]);
  }
  for (dx = [0 : ratchetstep : length - stalklength]) translate([dx,0,0]) {
    translate([ratchettoothsmoothr+0.5, armendwallthick/2, 0]) minkowski(){
      rotate([90,0,0])
	cylinder($fn=20, r=ratchettoothsmoothr, h=armendwallthick);
      multmatrix([	[	1, 0, ratchettoothslope, 0	],
			[	0,	1,	0,	0	],
			[	0,	0,	1,	0	],
			[	0,	0,	0,	1	]])
	cube([ratchettooth - ratchettoothsmoothr*2,
	      channelwidth, ratchettoothheight]);
    }
  }
}

module FilamentCupHandle(){
  pawlusewidth = ratchetpawl-ratchettoothsmoothr*2;
  mirror([0,1,0]) {
    cube([stalklength, stalkwidth, prongthick]);
    translate([stalklength, stalkwidth/2, 0])
      cylinder(r=stalkwidth/2, h=prongthick, $fn=20);
    translate([ratchettoothsmoothr, stalkwidth, 0]) {
      minkowski(){
	cylinder($fn=20,r=ratchettoothsmoothr, h=1);
	multmatrix([	[	1, -ratchettoothslope, 0, 0	],
			[	0,	1,	0,	0	],
			[	0,	0,	1,	0	],
			[	0,	0,	0,	1	]])
	  cube([pawlusewidth,
		ratchettoothheight - ratchettoothsmoothr,
		prongthick]);
      }
    }
  }
}

module FilamentCupCup(){
  xstraight = cupbigrad;
  linear_extrude(height=prongthick) {
    FlatArc(0,0, cupbigrad,cupbigrad+prongwidth, 89,271, $fn=80);
  }
  for (my=[0,1]) mirror([0,my,0]) {
    translate([0,cupbigrad,0])
      cube([xstraight, prongwidth, prongthick]);
  }
}

module FilamentCup() {
  FilamentCupHandle();

  dx = cupbigrad + prongwidth;
  dy = cupbigrad + prongwidth + overclipcupgap;

  translate([dx, dy, 0])
    FilamentCupCup();
  translate([0, -1, 0]);
  cube([prongwidth, dy+1, prongthick]);

  midrad = cupbigrad + prongwidth/2;

  propshift = stalklength - overclipdepth - prongthick;
  proptaken = propshift;
  echo(cupbigrad, dx, midrad, propshift, proptaken);

  translate([propshift, -1, 0])
    cube([prongwidth,
	  dy - sqrt(midrad*midrad - proptaken*proptaken),
	  prongthick]);
}

module CupSecuringClipSolid(w,d,h1,h2){
  rotate([0,-90,0]) translate([0,-h1/2,-w/2]) linear_extrude(height=w) {
    polygon(points=[[0,0], [d,0], [d,h2], [0,h1]]);
  }
}

module CupSecuringClipSolidSmooth(xrad=0, xdepth=0){
  hbase = totalheight + prongstalkxwidth - overcliproundr*2;
  minkowski(){
    CupSecuringClipSolid(w=totalwidth,
			 d=overclipdepth + xdepth,
			 h1=hbase - overclipsmaller,
			 h2=hbase + overclipbigger);
    cylinder($fn=20, h=0.01, r=overcliproundr+xrad);
  }
}

module CupSecuringClip(){
  wingswidth = wingspoke*2 + overclipthick*2 + overcliproundr*2 + totalwidth;
  difference(){
    union(){
      CupSecuringClipSolidSmooth(xrad=overclipthick, xdepth=0);
      translate([-wingswidth/2, -wingsize/2, 0])
	cube([wingswidth, wingsize, wingthick]);
    }
    translate([0,0,-0.1])
      CupSecuringClipSolidSmooth(xrad=0, xdepth=5);
  }
}

//ArmEnd();
//FilamentCup();
CupSecuringClip();
